unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, MkBootLoad, Vcl.ComCtrls,
  Vcl.Samples.Gauges,  MkFormSR, mk_usb_detector, Vcl.ExtCtrls,
  Vcl.Imaging.pngimage, Vcl.Buttons, Vcl.Imaging.jpeg;



type
  TForm1 = class(TForm)
    Button1: TBitBtn;
    Gauge1: TGauge;
    Memo1: TMemo;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    MkFormSR1: TMkFormSR;
    ListView1: TListView;
    MkUsbDetector1: TMkUsbDetector;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox2: TGroupBox;
    ComboBox1: TComboBox;
    Label1: TLabel;
    ComboBox2: TComboBox;
    Label4: TLabel;
    Button5: TButton;
    Panel1: TPanel;
    Button4: TButton;
    CheckBox1: TCheckBox;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Label5: TLabel;
    Image4: TImage;
    MkBootload1: TMkBootload;
    StatusBar1: TStatusBar;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    GroupBox3: TGroupBox;
    CheckBox2: TCheckBox;
    Edit3: TEdit;
    CheckBox3: TCheckBox;
    Bevel1: TBevel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MkBootload1Status(Sender: TObject; Description: string;
      Error: Integer);
    procedure MkBootload1UploadOK(Sender: TObject);
    procedure MkBootload1UploadStart(Sender: TObject; UploadSize: Integer);
    procedure MkBootload1InfoBLS(Sender: TObject; InfoBLS: TBLSINFO);
    procedure Button3Click(Sender: TObject);

    procedure Button4Click(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);
    procedure MkBootload1GetWiFiList(Sender: TObject; WiFiList: array of TWIFIitem;
      cnt: Integer);
    procedure Button5Click(Sender: TObject);
    procedure MkBootload1WiFiConnect(Sender: TObject; Success: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox1Click(Sender: TObject);
    procedure MkBootload1UploadProgress(Sender: TObject; UploadTime: string;
      Progress: Integer);
    procedure MkBootload1ActionEnd(Sender: TObject; action: TMBaction;
      status: Integer);
  private
//************************************************************ LIC **************************
    FVersion    : String;
    FRegisteredFor      : String;
    FLicFileDir         : String;
    procedure UstawParametryMkBootload;


    { Private declarations }
  public

    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.Button1Click(Sender: TObject);
begin
  Memo1.Clear;

  MkBootload1.UseATNEL_WIFI := CheckBox1.Checked;
  MkBootload1.UseSoftRST := CheckBox2.Checked;


  UstawParametryMkBootload;

  MkBootload1.CheckBLS;
end;


procedure TForm1.UstawParametryMkBootload;
begin
  //---- ustawienia WIFI ------------------
  MkBootload1.UseATNEL_WIFI := CheckBox1.Checked;
  MkBootload1.RemoteIP := Edit1.Text;
  MkBootload1.RemotePort := Edit2.Text;

  //---- ustawienia Serial COM Port ------------------
  MkBootload1.ComPort := ComboBox1.Text;
  MkBootload1.Baudrate := ComboBox2.Text;

  //---- ustawienia wsplne ------------------
  MkBootload1.UseSoftRST := CheckBox2.Checked;
  MkBootload1.SoftRSTCommand := Edit3.Text;
  MkBootload1.UseCRafterSoftRST := CheckBox3.Checked;
  MkBootload1.HwRstDTR := CheckBox4.Checked;
  MkBootload1.HwRstRTS := CheckBox5.Checked;
end;



procedure TForm1.Button3Click(Sender: TObject);
var
  i: Integer;
  lt: AnsiChar;
  path: String;
begin
  Memo1.Clear;
  Gauge1.Progress := 0;

  path := MkFormSR1.IniFile.ReadString( 'set', 'read_path', 'c:\' );
  OpenDialog1.InitialDir := path;
  OpenDialog1.FileName := '';

  if not OpenDialog1.Execute then Exit;

  path := ExtractFilePath( OpenDialog1.FileName );
  MkFormSR1.IniFile.WriteString( 'set', 'read_path', path );


  UstawParametryMkBootload;


  if OpenDialog1.FilterIndex = 1 then begin   // gdy wybrano plik HEX

    MkBootload1.ReadHexFromFile( OpenDialog1.FileName );
    MkBootload1.UploadHex;
  end else
  if OpenDialog1.FilterIndex = 2 then begin   // gdy wybrano plik BIN

    MkBootload1.ReadBinFromFile( OpenDialog1.FileName );
    MkBootload1.UploadBIN;
  end;

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Memo1.Clear;
  ListView1.Items.Clear;
  Screen.Cursor := crHourGlass;
  MkBootload1.GetWiFiModulesList;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if not MkBootload1.WiFiActive then begin
    MkBootload1.RemoteIP := Edit1.Text;
    MkBootload1.RemotePort := Edit2.Text;
    MkBootload1.WiFiActive := True;
    Button5.Caption := 'czekaj';
    Button5.Enabled := False;
  end else begin
    MkBootload1.WiFiActive := False;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if MkBootload1.WiFiActive then Exit;

  Button5.Enabled := CheckBox1.Checked;
end;

procedure TForm1.ComboBox1DropDown(Sender: TObject);
begin
  MkUsbDetector1.GetAvailableComPorts( ComboBox1.Items );
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MkFormSR1.IniFile.WriteString( 'set', 'remote_ip', Edit1.Text );
  MkFormSR1.IniFile.WriteString( 'set', 'remote_port', Edit2.Text );
  MkFormSR1.IniFile.WriteString( 'set', 'com_port', ComboBox1.Text );
  MkFormSR1.IniFile.WriteString( 'set', 'baud', ComboBox2.Text );
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  mList: TStringList;
begin
  ReportMemoryLeaksOnShutdown := True;

  Edit1.Text := MkFormSR1.IniFile.ReadString( 'set', 'remote_ip', '' );
  Edit2.Text := MkFormSR1.IniFile.ReadString( 'set', 'remote_port', '' );

  ComboBox1.Text := MkFormSR1.IniFile.ReadString( 'set', 'com_port', 'COM1' );
  ComboBox2.Text := MkFormSR1.IniFile.ReadString( 'set', 'baud', '9600' );

  if FileExists( 'MkBootloadLicence.txt' ) then begin
    mList := TStringList.Create;
    try
      mList.LoadFromFile( 'MkBootloadLicence.txt' );
      Memo1.Text := mList.Text;
    finally
      FreeAndNil( mList );
    end;
  end;



end;




procedure TForm1.ListView1DblClick(Sender: TObject);
begin
  if ListView1.Items.Count=0 then Exit;

  if ListView1.SelCount=0 then Exit;

  if MkBootload1.WiFiActive then Exit;


  Edit1.Text := ListView1.Selected.Caption;
  Edit2.Text := ListView1.Selected.SubItems[0];

end;



procedure TForm1.MkBootload1ActionEnd(Sender: TObject; action: TMBaction;
  status: Integer);
var
  str, err: String;
begin
  if action = _check_bls then str := 'Thread end, BLS ';

  if action = _upload then str := 'Thread end, Upload ';

  if status = 0 then err := 'OK' else err := 'error';


  Memo1.Lines.Add( str+err );

end;

procedure TForm1.MkBootload1GetWiFiList(Sender: TObject; WiFiList: array of TWIFIitem;
  cnt: Integer);
var
  lvItem: TListItem;
  i: Integer;
 mList: TStringList;
  buf, ip, port, name: String;
begin

  Screen.Cursor := crDefault;
  Memo1.Lines.Add( '-------- WiFi List ---------' );
  for i := 0 to cnt-1 do begin
    Memo1.Lines.Add( WiFiList[i].IP+' , '+WiFiList[i].Port+' , '+WiFiList[i].UDP_TCP+' , '
    +WiFiList[i].cln_srv+' , '+WiFiList[i].Baudrate+' , '+WiFiList[i].Name );
  end;


  ListView1.Items.Clear;

  for i := 0 to cnt-1 do begin

    lvItem := ListView1.Items.Add;
    lvItem.ImageIndex := 0;
    lvItem.Caption := WiFiList[i].IP;
    lvItem.SubItems.Add( WiFiList[i].Port );
    lvItem.SubItems.Add( WiFiList[i].Name );
    lvItem.SubItems.Add( WiFiList[i].Baudrate );

  end;

end;

procedure TForm1.MkBootload1InfoBLS(Sender: TObject; InfoBLS: TBLSINFO);
begin
  Memo1.Lines.Add('--- BLS INFO ---');
  Memo1.Lines.Add('PageSize: '+IntToStr(InfoBLS.PageSize));
  Memo1.Lines.Add('BLS Address: '+InfoBLS.BLSAddress);
  Memo1.Lines.Add('Microcontroller: '+InfoBLS.Microcontroller);
  Memo1.Lines.Add('F_CPU: '+InfoBLS.F_CPU+' MHz');
  Memo1.Lines.Add('BLS ver: '+InfoBLS.BLSVer);
  Memo1.Lines.Add('-----------------');
end;

procedure TForm1.MkBootload1Status(Sender: TObject; Description: string;
  Error: Integer);
begin
//  if Error <> 0 then Memo1.Lines.Add( 'error: '+IntToStr(Error)+  '   '+ Description);

  Memo1.Lines.Add( 'error: '+IntToStr(Error)+  '   '+ Description);

  if Error <> 0 then Screen.Cursor := crDefault;

  if Button5.Caption = 'czekaj' then Button5.Enabled := True;

end;

procedure TForm1.MkBootload1UploadOK(Sender: TObject);
begin
  Memo1.Lines.Add('Upload succesful');
end;



procedure TForm1.MkBootload1UploadProgress(Sender: TObject; UploadTime: string;
  Progress: Integer);
var
  i, v: Integer;
  str, bar, buf : String;
begin

//  Label5.Caption := ': '+IntToStr(Progress);
  Gauge1.Progress := Progress;
  i := Memo1.Lines.Count-1;
  str := '[';
  bar := '';
  bar := bar.PadRight( Progress div 2 , '=');
  v := 50-(length(bar) div 2);
  if v<=50 then v := v + (50-v);

  bar := bar.PadRight( v , '-' );
  str :=  str + bar + ']';

  buf := ' Progress '+IntToStr(Progress)+' % ';
  Delete( str, 19, Length(buf) );
  Insert(buf, str, 19);

  Memo1.Lines.Strings[i] := str;

  StatusBar1.Panels[1].Text := UploadTime;

end;

procedure TForm1.MkBootload1UploadStart(Sender: TObject; UploadSize: Integer);
begin
  Memo1.Lines.Add('BLS upload start, Firmware Size = '+IntToStr(UploadSize));
  Memo1.Lines.Add('[----------------- Progress 0 % -------------------]');
end;



procedure TForm1.MkBootload1WiFiConnect(Sender: TObject; Success: Boolean);
begin
  if Success then begin
    Panel1.Color := clAqua;
    Button5.Caption := 'STOP';
  end else begin
    Panel1.Color := clNavy;
    Button5.Caption := 'START';
  end;

  Label2.Enabled := not Success;
  Label3.Enabled := not Success;
  Edit1.Enabled := not Success;
  Edit2.Enabled := not Success;

end;

end.
